﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Text;
using System.Threading.Tasks;

namespace WinFormsApp2;

internal class NativeMethods
{
    internal struct SYSTEMTIME
    {
        internal short wYear;
        internal short wMonth;
        internal short wDayOfWeek;
        internal short wDay;
        internal short wHour;
        internal short wMinute;
        internal short wSecond;
        internal short wMilliseconds;
    }

    [DllImport("kernel32.dll", SetLastError = true)]
    internal static extern bool FileTimeToSystemTime([In] ref FILETIME lpFileTime, out SYSTEMTIME lpSystemTime);
    internal enum GETPROPERTYSTOREFLAGS
    {
        GPS_DEFAULT = 0,
        GPS_HANDLERPROPERTIESONLY = 0x1,
        GPS_READWRITE = 0x2,
        GPS_TEMPORARY = 0x4,
        GPS_FASTPROPERTIESONLY = 0x8,
        GPS_OPENSLOWITEM = 0x10,
        GPS_DELAYCREATION = 0x20,
        GPS_BESTEFFORT = 0x40,
        GPS_NO_OPLOCK = 0x80,
        GPS_PREFERQUERYPROPERTIES = 0x100,
        GPS_EXTRINSICPROPERTIES = 0x200,
        GPS_EXTRINSICPROPERTIESONLY = 0x400,
        GPS_VOLATILEPROPERTIES = 0x800,
        GPS_VOLATILEPROPERTIESONLY = 0x1000,
        GPS_MASK_VALID = 0x1fff
    }

    [DllImport("shell32.dll", SetLastError = true)]
    internal static extern HRESULT SHGetPropertyStoreFromParsingName([In][MarshalAs(UnmanagedType.LPWStr)] string pszPath, nint pbc, GETPROPERTYSTOREFLAGS flags, ref Guid riid, [Out, MarshalAs(UnmanagedType.Interface)] out IPropertyStore ppv);

}
